DEFINT A-Z
DECLARE SUB Redraw ()
DECLARE SUB PrintNumberMoves (Move%)
DECLARE SUB DrawDisks (Tower%, Disque%, Piece$)
DECLARE SUB DrawBoard ()
DECLARE SUB BadMove ()
DECLARE FUNCTION UpperTower (Tower)
DECLARE FUNCTION Winner ()

COMMON SHARED MaxNumberDisks, Okay, Green$, Bright$, Yellow$, Red$

' $INCLUDE: 'C:\QBasic\EasyDoor.BI'
' $INCLUDE: 'C:\QBasic\AutoBBS.BI'
' $INCLUDE: 'C:\QBasic\EasyANSI.BI'
' $INCLUDE: 'C:\QBasic\EasyPara.BI'


LOCATE , , 1

Init Para$(), NPara()
Send Bright$

IF AnsiFlag$ <> "1" THEN
        SendCLS
        SendCR "Sorry, but you need ANSI to play this game."
        SendCR ""
        PAUSE 36
        ReturnBBS
END IF

Start:
Move = 0
REDIM SHARED Tower(1 TO 3, 1 TO 7)
SendCLS
Redraw

AnsiLocate 19, 3
SendCR Bright$ + Green$ + "Hello " + LEFT$(FullName$ + "!", 25)

MaxNumberDisks = 0
WHILE MaxNumberDisks < 3 OR MaxNumberDisks > 6
        AnsiLocate 21, 3
        ModemInput Bright$ + Green$ + "How many disks do you want? (3-6): ", BlueBack$ + White$, MaxNumberDisks$, -1
        IF MaxNumberDisks$ = "Q" THEN GOTO Fin
        IF MaxNumberDisks$ = "R" THEN Redraw
        AnsiLocate 21, 3
        Send SPACE$(43)
        MaxNumberDisks = VAL(MaxNumberDisks$)
WEND

FOR I = MaxNumberDisks TO 1 STEP -1
    Tower(1, I) = I
NEXT

DrawBoard

WHILE Winner = 0
AskMove:
        Okay = 1
        PrintNumberMoves (Move)
        AnsiLocate 19, 3
        Send SPACE$(40)
        AnsiLocate 20, 3
        Send SPACE$(20)
        AnsiLocate 19, 3
        ModemInput Green$ + "Source Plate: ", BlueBack$ + White$, Source$, -1
        IF Source$ = "R" THEN Redraw: GOTO AskMove
        IF Source$ = "Q" THEN GOTO Fin
        AnsiLocate 20, 3
        ModemInput Green$ + "Destination Plate: ", BlueBack$ + White$, Dest$, -1
        IF Dest$ = "R" THEN Redraw: GOTO AskMove
        IF Dest$ = "Q" THEN GOTO Fin
        Source = VAL(Source$): Destination = VAL(Dest$)
        IF Source < 1 OR Source > MaxNumberDisks OR Destination < 1 OR Destination > MaxNumberDisks THEN BadMove: GOTO AskMove
        PositionS = UpperTower(Source)
        PositionD = UpperTower(Destination)

        
        IF PositionS = MaxNumberDisks + 1 OR Source = Destination THEN BadMove
        IF Tower(Destination, PositionD) <> 0 THEN
                IF Tower(Source, PositionS) > Tower(Destination, PositionD) THEN BadMove
        END IF

        IF Okay THEN
                DrawDisks Source, PositionS, " "
                Tower(Destination, PositionD - 1) = Tower(Source, PositionS)
                DrawDisks Destination, PositionD - 1, ""
                Tower(Source, PositionS) = 0
                Move = Move + 1
        END IF
       

WEND

PrintNumberMoves (Move)
AnsiLocate 19, 3
SendCR Yellow$ + "Congratulation, You made it in " + Num2Str$(Move) + " moves."
Fin:
AnsiLocate 20, 3
Send SPACE$(20)
AnsiLocate 21, 3
Send SPACE$(36)
AnsiLocate 21, 3
ModemInput Green$ + "Play again (y/N)? ", BlueBack$ + White$, Again$, -1
IF Again$ = "Y" THEN GOTO Start
SendCLS
LineFeed 3
SendCR Bright$ + Cyan$ + Center$("Thanks for using Towers of Hano") + Magenta$
AnsiBox 2, 22, 5, 60, 2
LineFeed 3
SendCR Green$ + Center$("Another great product using the EASY-DOOR Library")
SendCR Center$("for MS QuickBasic.")
PAUSE 36
ReturnBBS

SUB BadMove
Okay = 0
AnsiLocate 22, 3
SendBell
Send Red$ + "Illegal move!"
PAUSE 25
AnsiLocate 22, 3
Send SPACE$(15)
PurgeInBuffer
END SUB

SUB DrawBoard

FOR I = 1 TO 3
    FOR T = MaxNumberDisks TO 1 STEP -1
         IF Tower(I, T) <> 0 THEN DrawDisks I, T, ""
    NEXT
NEXT

END SUB

SUB DrawDisks (Tower, Disque, Piece$)

SELECT CASE Tower
        CASE IS = 1: X = 4
        CASE IS = 2: X = 24
        CASE IS = 3: X = 44
END SELECT

Lon = Tower(Tower, Disque)
AnsiLocate 10 - (MaxNumberDisks - 3) + Disque, X + ((6 - Lon))

SendCR Bright$ + Green$ + STRING$(Lon * 2, Piece$)

END SUB

SUB PrintNumberMoves (Move)
AnsiLocate 18, 74: SendCR Yellow$ + Num2Str$(Move)
END SUB

SUB Redraw

SendCLS
SendMenu "T_Hanoi", "", K$, 1
DrawBoard

END SUB

FUNCTION UpperTower (Tower)

UpperTowerTemp = 0

FOR I = 1 TO MaxNumberDisks
    IF Tower(Tower, I) <> 0 THEN
       UpperTowerTemp = I
       EXIT FOR
    END IF
NEXT

IF UpperTowerTemp = 0 THEN
    UpperTower = MaxNumberDisks + 1
ELSE
    UpperTower = UpperTowerTemp
END IF

END FUNCTION

FUNCTION Winner

WinTotal = 0
FOR I = 2 TO 3
    Win = 1
    FOR T = 1 TO MaxNumberDisks
        IF Tower(I, T) <> T THEN Win = 0
    NEXT
    IF Win = 1 THEN WinTotal = 1
NEXT

Winner = WinTotal

END FUNCTION

